/* config.h.  Generated from config.h.in by configure.  */
#ifndef __config_H
#define __config_H
/*
 * Copyright (c) 2001 Stephen Williams (steve@icarus.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#ifdef HAVE_CVS_IDENT
#ident "$Id: config.h.in,v 1.24 2007/06/13 01:03:57 steve Exp $"
#endif

#if defined(__cplusplus)
#  if !defined(__GNUC__)
     using namespace std;
#  elif (__GNUC__ == 3)
     using namespace std;
#  endif
#endif

# define SIZEOF_UNSIGNED_LONG_LONG 8
#ifndef SIZEOF_UNSIGNED_LONG
# define SIZEOF_UNSIGNED_LONG 8
#endif
# define SIZEOF_UNSIGNED 4

/* # undef NEED_LU */
/* # undef NEED_TU */
/* # undef WLU */
/* # undef WTU */
# define HAVE_IOSFWD 1
# define HAVE_DLFCN_H 1
/* # undef HAVE_DL_H */
# define HAVE_GETOPT_H 1
# define HAVE_MALLOC_H 1
/* # undef HAVE_LIBREADLINE */
/* # undef HAVE_READLINE_READLINE_H */
/* # undef HAVE_READLINE_HISTORY_H */
# define HAVE_INTTYPES_H 1
# define HAVE_LROUND 1
# define HAVE_NAN 1

/* Figure if I can use readline. */
/* #undef USE_READLINE */
#ifdef HAVE_LIBREADLINE
#ifdef HAVE_READLINE_READLINE_H
# define USE_READLINE
#endif
#endif

#ifndef MODULE_DIR
# define MODULE_DIR "."
#endif

#ifdef HAVE_INTTYPES_H
# include  <inttypes.h>
#endif

#if SIZEOF_UNSIGNED >= 8
typedef unsigned vvp_time64_t;
# define TIME_FMT ""
#else
# if SIZEOF_UNSIGNED_LONG >= 8
typedef unsigned long vvp_time64_t;
#  define TIME_FMT "l"
# else
#  if SIZEOF_UNSIGNED_LONG_LONG > SIZEOF_UNSIGNED_LONG
typedef unsigned long long vvp_time64_t;
#   define TIME_FMT "ll"
#  else
typedef unsigned long vvp_time64_t;
#   define TIME_FMT "l"
#  endif
# endif
#endif

# include  <math.h>

/* getrusage, /proc/self/statm */

# define HAVE_SYS_RESOURCE_H 1
# define LINUX 1

#if !defined(HAVE_LROUND)
#if defined(__cplusplus)
extern "C" long lround(double x);
#else
extern long lround(double x);
#endif
#endif

#if !defined(HAVE_NAN)
# define nan(x) (NAN)
#endif

#if !defined(INFINITY)
# define INFINITY HUGE_VAL
#endif

/*
 * When doing dynamic linking, we need a uniform way to identify the
 * symbol. Some compilers put leading _, some trailing _. The
 * configure script figures out which is the local convention and
 * defines NEED_LU and NEED_TU as required.
 */
#ifdef NEED_LU
#define LU "_"
#else
#define LU ""
#endif

#ifdef NEED_TU
#define TU "_"
#else
#define TU ""
#endif

/*
 * $Log: config.h.in,v $
 * Revision 1.24  2007/06/13 01:03:57  steve
 *  Detect and use the nan function.
 *
 * Revision 1.23  2007/02/02 04:33:01  steve
 *  Use inttypes.h instead of stdint.h for portability.
 *
 * Revision 1.22  2006/04/27 05:04:59  steve
 *  Detect missing lround function.
 *
 * Revision 1.21  2006/04/25 22:41:10  steve
 *  Detect the presence of stdint.h
 *
 * Revision 1.20  2005/09/14 02:50:07  steve
 *  Add word integer compares.
 *
 * Revision 1.19  2005/04/13 06:34:20  steve
 *  Add vvp driver functor for logic outputs,
 *  Add ostream output operators for debugging.
 *
 * Revision 1.18  2004/10/04 01:10:59  steve
 *  Clean up spurious trailing white space.
 *
 * Revision 1.17  2004/05/18 18:45:11  steve
 *  Handle explicit set of unsigned long width. For -m32
 *
 * Revision 1.16  2003/08/26 16:26:02  steve
 *  ifdef idents correctly.
 *
 * Revision 1.15  2003/05/20 03:48:23  steve
 *  Fix spelling of HAVE_LIBREADLINE
 *
 * Revision 1.14  2003/05/16 03:50:28  steve
 *  Fallback functionality if readline is not present.
 *
 * Revision 1.13  2003/03/13 20:31:40  steve
 *  Warnings about long long time.
 *
 * Revision 1.12  2003/03/13 04:36:57  steve
 *  Remove the obsolete functor delete functions.
 *
 * Revision 1.11  2002/05/24 00:43:16  steve
 *  Define SIZEOF_UNSIGNED_LONG_LONG
 *
 * Revision 1.10  2002/04/20 04:33:23  steve
 *  Support specified times in cbReadOnlySync, and
 *  add support for cbReadWriteSync.
 *  Keep simulation time in a 64bit number.
 *
 * Revision 1.9  2001/10/20 01:03:42  steve
 *  Print memory usage information if requested (Stephan Boettcher)
 *
 * Revision 1.8  2001/09/17 22:26:33  steve
 *  Detect C name mangling for dlsym.
 *
 * Revision 1.7  2001/09/15 18:27:05  steve
 *  Make configure detect malloc.h
 *
 * Revision 1.6  2001/07/16 18:40:19  steve
 *  Add a stdlog output for vvp, and vvp options
 *  to direct them around. (Stephan Boettcher.)
 *
 * Revision 1.5  2001/05/11 02:06:14  steve
 *  Add the --enable-vvp-debug option to the configure
 *  script of vvp, and detect getopt.h.
 *
 * Revision 1.4  2001/05/05 23:55:46  steve
 *  Add the beginnings of an interactive debugger.
 *
 * Revision 1.3  2001/03/22 21:26:53  steve
 *  Compile in a default VPI module dir.
 *
 * Revision 1.2  2001/03/16 01:44:34  steve
 *  Add structures for VPI support, and all the %vpi_call
 *  instruction. Get linking of VPI modules to work.
 *
 * Revision 1.1  2001/03/11 00:29:38  steve
 *  Add the vvp engine to cvs.
 *
 */
#endif
